import{s as W,n as D,o as K}from"../chunks/scheduler.37c15a92.js";import{S as Q,i as V,g as i,s as m,r as X,m as B,H as Y,A as Z,h as o,f as e,c as p,j as A,u as tt,x as v,n as I,B as et,k as R,y as _,a as n,v as at,d as nt,t as st,w as it}from"../chunks/index.7cb9c9b8.js";import{H as ot}from"../chunks/Heading.d3928e2a.js";function lt(z){let l,P,w,b,c,T,h,U="The idea with Proximal Policy Optimization (PPO) is that we want to improve the training stability of the policy by limiting the change you make to the policy at each training epoch: <strong>we want to avoid having too large of a policy update.</strong>",C,u,j="For two reasons:",k,g,G="<li>We know empirically that smaller policy updates during training are <strong>more likely to converge to an optimal solution.</strong></li> <li>A too-big step in a policy update can result in falling “off the cliff” (getting a bad policy) <strong>and taking a long time or even having no possibility to recover.</strong></li>",H,r,q='<img class="center" src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit9/cliff.jpg" alt="Policy Update cliff"/> <figcaption>Taking smaller policy updates to improve the training stability</figcaption> <figcaption>Modified version from RL — Proximal Policy Optimization (PPO) <a href="https://jonathan-hui.medium.com/rl-proximal-policy-optimization-ppo-explained-77f014ec3f12">Explained by Jonathan Hui</a></figcaption>',M,s,f,F="So with PPO, we update the policy conservatively",S,L,J='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mo stretchy="false">[</mo><mn>1</mn><mo>−</mo><mi>ϵ</mi><mo separator="true">,</mo><mn>1</mn><mo>+</mo><mi>ϵ</mi><mo stretchy="false">]</mo></mrow><annotation encoding="application/x-tex"> [1 - \\epsilon, 1 + \\epsilon] </annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mopen">[</span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:0.8389em;vertical-align:-0.1944em;"></span><span class="mord mathnormal">ϵ</span><span class="mpunct">,</span><span class="mspace" style="margin-right:0.1667em;"></span><span class="mord">1</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">+</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1em;vertical-align:-0.25em;"></span><span class="mord mathnormal">ϵ</span><span class="mclose">]</span></span></span></span>',$,d,N="remove the incentive for the current policy to go too far from the old one (hence the proximal policy term).",O,x,E;return c=new ot({props:{title:"The intuition behind PPO",local:"the-intuition-behind-ppo",headingTag:"h1"}}),{c(){l=i("meta"),P=m(),w=i("p"),b=m(),X(c.$$.fragment),T=m(),h=i("p"),h.innerHTML=U,C=m(),u=i("p"),u.textContent=j,k=m(),g=i("ul"),g.innerHTML=G,H=m(),r=i("figure"),r.innerHTML=q,M=m(),s=i("p"),f=i("strong"),f.textContent=F,S=B(". To do so, we need to measure how much the current policy changed compared to the former one using a ratio calculation between the current and former policy. And we clip this ratio in a range "),L=new Y(!1),$=B(", meaning that we "),d=i("strong"),d.textContent=N,O=m(),x=i("p"),this.h()},l(t){const a=Z("svelte-u9bgzb",document.head);l=o(a,"META",{name:!0,content:!0}),a.forEach(e),P=p(t),w=o(t,"P",{}),A(w).forEach(e),b=p(t),tt(c.$$.fragment,t),T=p(t),h=o(t,"P",{"data-svelte-h":!0}),v(h)!=="svelte-1v0k3v2"&&(h.innerHTML=U),C=p(t),u=o(t,"P",{"data-svelte-h":!0}),v(u)!=="svelte-158km42"&&(u.textContent=j),k=p(t),g=o(t,"UL",{"data-svelte-h":!0}),v(g)!=="svelte-24i75q"&&(g.innerHTML=G),H=p(t),r=o(t,"FIGURE",{class:!0,"data-svelte-h":!0}),v(r)!=="svelte-1uo863i"&&(r.innerHTML=q),M=p(t),s=o(t,"P",{});var y=A(s);f=o(y,"STRONG",{"data-svelte-h":!0}),v(f)!=="svelte-10ggtbr"&&(f.textContent=F),S=I(y,". To do so, we need to measure how much the current policy changed compared to the former one using a ratio calculation between the current and former policy. And we clip this ratio in a range "),L=et(y,!1),$=I(y,", meaning that we "),d=o(y,"STRONG",{"data-svelte-h":!0}),v(d)!=="svelte-hv01ak"&&(d.textContent=N),y.forEach(e),O=p(t),x=o(t,"P",{}),A(x).forEach(e),this.h()},h(){R(l,"name","hf:doc:metadata"),R(l,"content",rt),R(r,"class","image table text-center m-0 w-full"),L.a=$},m(t,a){_(document.head,l),n(t,P,a),n(t,w,a),n(t,b,a),at(c,t,a),n(t,T,a),n(t,h,a),n(t,C,a),n(t,u,a),n(t,k,a),n(t,g,a),n(t,H,a),n(t,r,a),n(t,M,a),n(t,s,a),_(s,f),_(s,S),L.m(J,s),_(s,$),_(s,d),n(t,O,a),n(t,x,a),E=!0},p:D,i(t){E||(nt(c.$$.fragment,t),E=!0)},o(t){st(c.$$.fragment,t),E=!1},d(t){t&&(e(P),e(w),e(b),e(T),e(h),e(C),e(u),e(k),e(g),e(H),e(r),e(M),e(s),e(O),e(x)),e(l),it(c,t)}}}const rt='{"title":"The intuition behind PPO","local":"the-intuition-behind-ppo","sections":[],"depth":1}';function mt(z){return K(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ut extends Q{constructor(l){super(),V(this,l,mt,lt,W,{})}}export{ut as component};
